From c00d79bae229d2c6edab14db678afb59501ad46c Mon Sep 17 00:00:00 2001
From: Milan Crha <mcrha@redhat.com>
Date: Thu, 2 Apr 2020 09:24:28 +0200
Subject: [PATCH 6/6] calendar-server: Improve performance by properly using
 ECalClientView

The previous code always restarted whole ECalClientView when it received
any changes in it, which could sometimes lead to constant repeated restarts
of the view.

https://gitlab.gnome.org/GNOME/gnome-shell/-/issues/1875
---
 .../org.gnome.Shell.CalendarServer.xml        |   19 +-
 js/ui/calendar.js                             |  104 +-
 meson.build                                   |    2 +-
 src/calendar-server/calendar-sources.c        |  677 +++++------
 src/calendar-server/calendar-sources.h        |   29 +-
 .../gnome-shell-calendar-server.c             | 1026 ++++++++---------
 6 files changed, 921 insertions(+), 915 deletions(-)

diff --git a/js/ui/calendar.js b/js/ui/calendar.js
index 88e008e..7bbdaaf 100644
--- a/js/ui/calendar.js
+++ b/js/ui/calendar.js
@@ -183,7 +183,12 @@ var DBusEventSource = class DBusEventSource {
                 }
             }
 
-            this._dbusProxy.connectSignal('Changed', this._onChanged.bind(this));
+            this._dbusProxy.connectSignal('EventsAddedOrUpdated',
+                this._onEventsAddedOrUpdated.bind(this));
+            this._dbusProxy.connectSignal('EventsRemoved',
+                this._onEventsRemoved.bind(this));
+            this._dbusProxy.connectSignal('ClientDisappeared',
+                this._onClientDisappeared.bind(this));
 
             this._dbusProxy.connect('notify::g-name-owner', () => {
                 if (this._dbusProxy.g_name_owner)
@@ -216,7 +221,7 @@ var DBusEventSource = class DBusEventSource {
     }
 
     _resetCache() {
-        this._events = [];
+        this._events = new Map();
         this._lastRequestBegin = null;
         this._lastRequestEnd = null;
     }
@@ -232,28 +237,47 @@ var DBusEventSource = class DBusEventSource {
         this.emit('changed');
     }
 
-    _onChanged() {
-        this._loadEvents(false);
-    }
+    _onEventsAddedOrUpdated(dbusProxy, nameOwner, argArray) {
+        const [appointments = []] = argArray;
+        let changed = false;
 
-    _onEventsReceived(results, _error) {
-        let newEvents = [];
-        let appointments = results[0] || [];
         for (let n = 0; n < appointments.length; n++) {
-            let a = appointments[n];
-            let date = new Date(a[4] * 1000);
-            let end = new Date(a[5] * 1000);
-            let id = a[0];
-            let summary = a[1];
-            let allDay = a[3];
+            const [id, summary, allDay, startTime, endTime] = appointments[n];
+            const date = new Date(startTime * 1000);
+            const end = new Date(endTime * 1000);
             let event = new CalendarEvent(id, date, end, summary, allDay);
-            newEvents.push(event);
+            this._events.set(event.id, event);
+
+            changed = true;
         }
-        newEvents.sort((ev1, ev2) => ev1.date.getTime() - ev2.date.getTime());
 
-        this._events = newEvents;
-        this.isLoading = false;
-        this.emit('changed');
+        if (changed)
+            this.emit('changed');
+    }
+
+    _onEventsRemoved(dbusProxy, nameOwner, argArray) {
+        const [ids = []] = argArray;
+
+        let changed = false;
+        for (const id of ids)
+            changed |= this._events.delete(id);
+
+        if (changed)
+            this.emit('changed');
+    }
+
+    _onClientDisappeared(dbusProxy, nameOwner, argArray) {
+        let [sourceUid = ''] = argArray;
+        sourceUid += '\n';
+
+        let changed = false;
+        for (const id of this._events.keys()) {
+            if (id.startsWith(sourceUid))
+                changed |= this._events.delete(id);
+        }
+
+        if (changed)
+            this.emit('changed');
     }
 
     _loadEvents(forceReload) {
@@ -262,34 +286,38 @@ var DBusEventSource = class DBusEventSource {
             return;
 
         if (this._curRequestBegin && this._curRequestEnd) {
-            this._dbusProxy.GetEventsRemote(this._curRequestBegin.getTime() / 1000,
-                                            this._curRequestEnd.getTime() / 1000,
-                                            forceReload,
-                                            this._onEventsReceived.bind(this),
-                                            Gio.DBusCallFlags.NONE);
+            if (forceReload) {
+                this._events.clear();
+                this.emit('changed');
+            }
+            this._dbusProxy.SetTimeRangeRemote(
+                this._curRequestBegin.getTime() / 1000,
+                this._curRequestEnd.getTime() / 1000,
+                forceReload,
+                Gio.DBusCallFlags.NONE);
         }
     }
 
     requestRange(begin, end) {
         if (!(_datesEqual(begin, this._lastRequestBegin) && _datesEqual(end, this._lastRequestEnd))) {
-            this.isLoading = true;
             this._lastRequestBegin = begin;
             this._lastRequestEnd = end;
             this._curRequestBegin = begin;
             this._curRequestEnd = end;
-            this._loadEvents(false);
+            this._loadEvents(true);
+        }
+    }
+
+    *_getFilteredEvents(begin, end) {
+        for (const event of this._events.values()) {
+            if (_dateIntervalsOverlap(event.date, event.end, begin, end))
+                yield event;
         }
     }
 
     getEvents(begin, end) {
-        let result = [];
-        for (let n = 0; n < this._events.length; n++) {
-            let event = this._events[n];
+        let result = [...this._getFilteredEvents(begin, end)];
 
-            if (_dateIntervalsOverlap (event.date, event.end, begin, end)) {
-                result.push(event);
-            }
-        }
         result.sort((event1, event2) => {
             // sort events by end time on ending day
             let d1 = event1.date < begin && event1.end <= end ? event1.end : event1.date;
@@ -303,12 +331,8 @@ var DBusEventSource = class DBusEventSource {
         let dayBegin = _getBeginningOfDay(day);
         let dayEnd = _getEndOfDay(day);
 
-        let events = this.getEvents(dayBegin, dayEnd);
-
-        if (events.length == 0)
-            return false;
-
-        return true;
+        const { done } = this._getFilteredEvents(dayBegin, dayEnd).next();
+        return !done;
     }
 };
 Signals.addSignalMethods(DBusEventSource.prototype);
@@ -821,7 +845,7 @@ var EventsSection = class EventsSection extends MessageList.MessageListSection {
     }
 
     _reloadEvents() {
-        if (this._eventSource.isLoading)
+        if (this._eventSource.isLoading || this._reloading)
             return;
 
         this._reloading = true;
diff --git a/meson.build b/meson.build
index 8663b1d..712a3f5 100644
--- a/meson.build
+++ b/meson.build
@@ -20,7 +20,7 @@ libmutter_pc = 'libmutter-' + mutter_api_version
 
 croco_req = '>= 0.6.8'
 ecal_req = '>= 3.33.1'
-eds_req = '>= 3.17.2'
+eds_req = '>= 3.33.1'
 gcr_req = '>= 3.7.5'
 gio_req = '>= 2.56.0'
 gi_req = '>= 1.49.1'
